Codeforces Round #363 (Div. 2) 698B Fix a Tree

D. Fix a Tree
time limit per test
2 seconds
memory limit per test
256 megabytes
 
 

A tree is an undirected connected graph without cycles.

Let's consider a rooted undirected tree with n vertices, numbered 1 through n. There are many ways to represent such a tree. One way is to create an array with n integers p1, p2, ..., pn, where pi denotes a parent of vertex i (here, for convenience a root is considered its own parent).

For this rooted tree the array p is [2, 3, 3, 2].

Given a sequence p1, p2, ..., pn, one is able to restore a tree:

  1. There must be exactly one index r that pr = r. A vertex r is a root of the tree.
  2. For all other n - 1 vertices i, there is an edge between vertex i and vertex pi.

A sequence p1, p2, ..., pn is called valid if the described procedure generates some (any) rooted tree. For example, for n = 3 sequences(1,2,2), (2,3,1) and (2,1,3) are not valid.

You are given a sequence a1, a2, ..., an, not necessarily valid. Your task is to change the minimum number of elements, in order to get a valid sequence. Print the minimum number of changes and an example of a valid sequence after that number of changes. If there are many valid sequences achievable in the minimum number of changes, print any of them.

Input

The first line of the input contains an integer n (2 ≤ n ≤ 200 000) — the number of vertices in the tree.

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ n).

Output

In the first line print the minimum number of elements to change, in order to get a valid sequence.

In the second line, print any valid sequence possible to get from (a1, a2, ..., an) in the minimum number of changes. If there are many such sequences, any of them will be accepted.

Examples
input
4
2 3 3 4
output
1
2 3 4 4
input
5
3 2 2 5 3
output
0
3 2 2 5 3
input
8
2 3 5 4 1 6 6 7
output
2
2 3 7 8 1 6 6 7
Note

In the first sample, it's enough to change one element. In the provided output, a sequence represents a tree rooted in a vertex 4(because p4 = 4), which you can see on the left drawing below. One of other correct solutions would be a sequence 2 3 3 2, representing a tree rooted in vertex 3 (right drawing below). On both drawings, roots are painted red.

In the second sample, the given sequence is already valid.

       当时打这场的时候并查集一直歪了(大哭状)所以挂掉了,隔天才补上去的,算是一道并查集的水题吧,多注意点细节就可以了。

思路:

      数组a【i】存放的是它所属的父亲,所以有3种情况:

① 当i==a【i】则说明i可以作为最终树的一个根,那么就先把这个根存起来,下次再遇到i==a【i】的情况,直接unite(i,root)并且sum++就可以了;

② 当i!=a【i】&&!same(i,a【i】)时,就直接unite(i,a【i】);

③ 当i!=a【i】&&same(i,a【i】)时,说明存在环,那么此时先判断根root是否有先找到了。如果没有就直接另root=i并且使a【i】=i,sum++;

    而如果根存在的话,就直接a【i】=root,unite(i,root)再sum++。

  1 #include <iostream>
  2 #include <queue>
  3 #include <stack>
  4 #include <cstdio>
  5 #include <vector>
  6 #include <map>
  7 #include <set>
  8 #include <algorithm>
  9 #include <cmath>
 10 #include <cstring>
 11 #include <cstdlib>
 12 #include <string>
 13 #include <sstream>
 14 #define lson l,m,rt*2
 15 #define rson m+1,r,rt*2+1
 16 #define mod 998244353
 17 #define INF 0x3f3f3f3f
 18 using namespace std;
 19 typedef long long LL;
 20 int pre[200006],n,a[200006],rank[200006];
 21 void init(int n)
 22 {
 23     for(int i=1; i<=n; i++)
 24     {
 25         pre[i]=i;
 26         rank[i]=0;
 27     }
 28 }
 29 int find(int x)
 30 {
 31     if(pre[x]==x)
 32     {
 33         return x;
 34     }
 35     else return pre[x]=find(pre[x]);
 36 }
 37 void unite(int x,int y)
 38 {
 39     int fx=find(x);
 40     int fy=find(y);
 41     if(fx!=fy)
 42     {
 43         pre[fx]=fy;
 44     }
 45 }
 46 bool same(int x,int y)
 47 {
 48     return find(x)==find(y);
 49 }
 50 int main()
 51 {
 52 #ifdef Local
 53     freopen("data.txt","r",stdin);
 54 #endif
 55     int i,j,k,n,m,sum=0,root=0,p;
 56     cin>>n;
 57     init(n);
 58     for(i=1; i<=n; i++)
 59     {
 60         scanf("%d",&a[i]);
 61         if(a[i]==i&&!root)root=i;
 62     }
 63     for(i=1; i<=n; i++)
 64     {
 65         if(a[i]==i)
 66         {
 67             if(!root)
 68             {
 69                 root=i;
 70             }
 71             else
 72             {
 73                 if(i!=root)
 74                 {
 75                     unite(i,root);
 76                     a[i]=root;
 77                     sum++;
 78                 }
 79             }
 80         }
 81         else
 82         {
 83             if(!same(i,a[i]))unite(i,a[i]);
 84             else
 85             {
 86                 if(!root)
 87                 {
 88                     root=i;
 89                     sum++;
 90                     a[i]=i;
 91                 }
 92                 else
 93                 {
 94                     unite(i,root);
 95                     a[i]=root;
 96                     sum++;
 97                 }
 98             }
 99         }
100     }
101     cout<<sum<<endl;
102     for(i=1; i<=n; i++)
103     {
104         if(i==n)cout<<a[i]<<endl;
105         else cout<<a[i]<<" ";
106     }
107     return 0;
108 }
View Code
原文地址:https://www.cnblogs.com/27sx/p/5687740.html